package com.hotwj.platform.config.vehicleThreeInspectItem.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.config.vehicleThreeInspectItem.domain.HotVehicleThreeInspectItem;
import com.hotwj.platform.config.vehicleThreeInspectItem.domain.bo.HotVehicleThreeInspectItemBo;
import com.hotwj.platform.config.vehicleThreeInspectItem.domain.vo.HotVehicleThreeInspectItemVo;
import com.hotwj.platform.config.vehicleThreeInspectItem.mapper.HotVehicleThreeInspectItemMapper;
import com.hotwj.platform.config.vehicleThreeInspectItem.service.IHotVehicleThreeInspectItemService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 车辆三检检查项Service业务层处理
 *
 * @author shihongwei
 * @date 2025-12-29
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotVehicleThreeInspectItemServiceImpl implements IHotVehicleThreeInspectItemService {

    private final HotVehicleThreeInspectItemMapper baseMapper;

    /**
     * 查询车辆三检检查项
     *
     * @param id 主键
     * @return 车辆三检检查项
     */
    @Override
    public HotVehicleThreeInspectItemVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询车辆三检检查项列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 车辆三检检查项分页列表
     */
    @Override
    public TableDataInfo<HotVehicleThreeInspectItemVo> queryPageList(HotVehicleThreeInspectItemBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotVehicleThreeInspectItem> lqw = buildQueryWrapper(bo);
        Page<HotVehicleThreeInspectItemVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的车辆三检检查项列表
     *
     * @param bo 查询条件
     * @return 车辆三检检查项列表
     */
    @Override
    public List<HotVehicleThreeInspectItemVo> queryList(HotVehicleThreeInspectItemBo bo) {
        LambdaQueryWrapper<HotVehicleThreeInspectItem> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotVehicleThreeInspectItem> buildQueryWrapper(HotVehicleThreeInspectItemBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotVehicleThreeInspectItem> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotVehicleThreeInspectItem::getSortNo);
        lqw.eq(bo.getCompanyId() != null, HotVehicleThreeInspectItem::getCompanyId, bo.getCompanyId());
        lqw.eq(bo.getInspectId() != null, HotVehicleThreeInspectItem::getInspectId, bo.getInspectId());
        lqw.eq(bo.getInspectType() != null, HotVehicleThreeInspectItem::getInspectType, bo.getInspectType());
        lqw.eq(bo.getSortNo() != null, HotVehicleThreeInspectItem::getSortNo, bo.getSortNo());
        lqw.eq(bo.getIsDeleted() != null, HotVehicleThreeInspectItem::getIsDeleted, bo.getIsDeleted());
        return lqw;
    }

    /**
     * 新增车辆三检检查项
     *
     * @param bo 车辆三检检查项
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotVehicleThreeInspectItemBo bo) {
        HotVehicleThreeInspectItem add = MapstructUtils.convert(bo, HotVehicleThreeInspectItem.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改车辆三检检查项
     *
     * @param bo 车辆三检检查项
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotVehicleThreeInspectItemBo bo) {
        HotVehicleThreeInspectItem update = MapstructUtils.convert(bo, HotVehicleThreeInspectItem.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotVehicleThreeInspectItem entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除车辆三检检查项信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
